]> CyberLeo.Net >> Repos - FreeBSD/FreeBSD.git/blob - usr.sbin/crashinfo/crashinfo.sh
Notable upstream pull request merges:
[FreeBSD/FreeBSD.git] / usr.sbin / crashinfo / crashinfo.sh
1 #!/bin/sh
2 #
3 # SPDX-License-Identifier: BSD-3-Clause
4 #
5 # Copyright (c) 2008 Yahoo!, Inc.
6 # All rights reserved.
7 #
8 # Redistribution and use in source and binary forms, with or without
9 # modification, are permitted provided that the following conditions
10 # are met:
11 # 1. Redistributions of source code must retain the above copyright
12 #    notice, this list of conditions and the following disclaimer.
13 # 2. Redistributions in binary form must reproduce the above copyright
14 #    notice, this list of conditions and the following disclaimer in the
15 #    documentation and/or other materials provided with the distribution.
16 # 3. Neither the name of the author nor the names of any co-contributors
17 #    may be used to endorse or promote products derived from this software
18 #    without specific prior written permission.
19 #
20 # THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
21 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
22 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
23 # ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
24 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
25 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
26 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
27 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
28 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
29 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
30 # SUCH DAMAGE.
31 #
32
33 usage()
34 {
35         echo "usage: crashinfo [-b] [-d crashdir] [-n dumpnr]" \
36                 "[-k kernel] [core]"
37         exit 1
38 }
39
40 # Remove an uncompressed copy of a dump
41 cleanup()
42 {
43
44         [ -e $VMCORE ] && rm -f $VMCORE
45 }
46
47 # Run a single gdb command against a kernel file in batch mode.
48 # The kernel file is specified as the first argument and the command
49 # is given in the remaining arguments.
50 gdb_command()
51 {
52         local k
53
54         k=$1 ; shift
55
56         ${GDB} -batch -ex "$@" $k
57 }
58
59 find_kernel()
60 {
61         local ivers k kvers
62
63         ivers=$(awk '
64         /Version String/ {
65                 print
66                 nextline=1
67                 next
68         }
69         nextline==1 {
70                 if ($0 ~ "^  [A-Za-z ]+: ") {
71                         nextline=0
72                 } else {
73                         print
74                 }
75         }' $INFO)
76
77         # Look for a matching kernel version, handling possible truncation
78         # of the version string recovered from the dump.
79         for k in `sysctl -n kern.bootfile` $(ls -t /boot/*/kernel); do
80                 kvers=$(gdb_command $k 'printf "  Version String: %s", version' | \
81                     awk "{line=line\$0\"\n\"} END{print substr(line,1,${#ivers})}" \
82                     2>/dev/null)
83                 if [ "$ivers" = "$kvers" ]; then
84                         KERNEL=$k
85                         break
86                 fi
87         done
88 }
89
90 BATCH=false
91 CRASHDIR=/var/crash
92 DUMPNR=
93 KERNEL=
94
95 while getopts "bd:n:k:" opt; do
96         case "$opt" in
97         b)
98                 BATCH=true
99                 ;;
100         d)
101                 CRASHDIR=$OPTARG
102                 ;;
103         n)
104                 DUMPNR=$OPTARG
105                 ;;
106         k)
107                 KERNEL=$OPTARG
108                 ;;
109         \?)
110                 usage
111                 ;;
112         esac
113 done
114
115 shift $((OPTIND - 1))
116
117 if [ $# -eq 1 ]; then
118         if [ -n "$DUMPNR" ]; then
119                 echo "-n and an explicit vmcore are mutually exclusive"
120                 usage
121         fi
122
123         # Figure out the crash directory and number from the vmcore name.
124         CRASHDIR=`dirname $1`
125         DUMPNR=$(expr $(basename $1) : 'vmcore\.\([0-9]*\)')
126         if [ -z "$DUMPNR" ]; then
127                 echo "Unable to determine dump number from vmcore file $1."
128                 exit 1
129         fi
130 elif [ $# -gt 1 ]; then
131         usage
132 else
133         # If we don't have an explicit dump number, operate on the most
134         # recent dump.
135         if [ -z "$DUMPNR" ]; then
136                 if ! [ -r $CRASHDIR/bounds ]; then
137                         echo "No crash dumps in $CRASHDIR."
138                         exit 1
139                 fi                      
140                 next=`cat $CRASHDIR/bounds`
141                 if [ -z "$next" ] || [ "$next" -eq 0 ]; then
142                         echo "No crash dumps in $CRASHDIR."
143                         exit 1
144                 fi
145                 DUMPNR=$(($next - 1))
146         fi
147 fi
148
149 VMCORE=$CRASHDIR/vmcore.$DUMPNR
150 INFO=$CRASHDIR/info.$DUMPNR
151 FILE=$CRASHDIR/core.txt.$DUMPNR
152 HOSTNAME=`hostname`
153
154 if $BATCH; then
155         echo "Writing crash summary to $FILE."
156         exec > $FILE 2>&1
157 fi
158
159 GDB=/usr/local/bin/gdb
160 if [ ! -x "$GDB" ]; then
161         echo "Unable to find a kernel debugger."
162         echo "Please install the devel/gdb port or gdb package."
163         exit 1
164 fi
165
166 if [ ! -e $VMCORE ]; then
167         if [ -e $VMCORE.gz ]; then
168                 trap cleanup EXIT HUP INT QUIT TERM
169                 gzcat $VMCORE.gz > $VMCORE
170         elif [ -e $VMCORE.zst ]; then
171                 trap cleanup EXIT HUP INT QUIT TERM
172                 zstdcat $VMCORE.zst > $VMCORE
173         else
174                 echo "$VMCORE not found"
175                 exit 1
176         fi
177 fi
178
179 if [ ! -e $INFO ]; then
180         echo "$INFO not found"
181         exit 1
182 fi
183
184 # If the user didn't specify a kernel, then try to find one.
185 if [ -z "$KERNEL" ]; then
186         find_kernel
187         if [ -z "$KERNEL" ]; then
188                 echo "Unable to find matching kernel for $VMCORE"
189                 exit 1
190         fi
191 elif [ ! -e $KERNEL ]; then
192         echo "$KERNEL not found"
193         exit 1
194 fi
195
196 umask 077
197
198 # Simulate uname
199 ostype=$(gdb_command $KERNEL 'printf "%s", ostype')
200 osrelease=$(gdb_command $KERNEL 'printf "%s", osrelease')
201 version=$(gdb_command $KERNEL 'printf "%s", version' | tr '\t\n' '  ')
202 machine=$(gdb_command $KERNEL 'printf "%s", machine')
203
204 if ! $BATCH; then
205         echo "Writing crash summary to $FILE."
206         exec > $FILE 2>&1
207 fi
208
209 echo "$HOSTNAME dumped core - see $VMCORE"
210 echo
211 date
212 echo
213 echo "$ostype $HOSTNAME $osrelease $version $machine"
214 echo
215 sed -ne '/^  Panic String: /{s//panic: /;p;}' $INFO
216 echo
217
218 # XXX: /bin/sh on 7.0+ is broken so we can't simply pipe the commands to
219 # kgdb via stdin and have to use a temporary file instead.
220 file=`mktemp /tmp/crashinfo.XXXXXX`
221 if [ $? -eq 0 ]; then
222         echo "bt -full" >> $file
223         echo "quit" >> $file
224         ${GDB%gdb}kgdb $KERNEL $VMCORE < $file
225         rm -f $file
226         echo
227 fi
228 echo
229
230 echo "------------------------------------------------------------------------"
231 echo "ps -axlww"
232 echo
233 ps -M $VMCORE -N $KERNEL -axlww
234 echo
235
236 echo "------------------------------------------------------------------------"
237 echo "vmstat -s"
238 echo
239 vmstat -M $VMCORE -N $KERNEL -s
240 echo
241
242 echo "------------------------------------------------------------------------"
243 echo "vmstat -m"
244 echo
245 vmstat -M $VMCORE -N $KERNEL -m
246 echo
247
248 echo "------------------------------------------------------------------------"
249 echo "vmstat -z"
250 echo
251 vmstat -M $VMCORE -N $KERNEL -z
252 echo
253
254 echo "------------------------------------------------------------------------"
255 echo "vmstat -i"
256 echo
257 vmstat -M $VMCORE -N $KERNEL -i
258 echo
259
260 echo "------------------------------------------------------------------------"
261 echo "pstat -T"
262 echo
263 pstat -M $VMCORE -N $KERNEL -T
264 echo
265
266 echo "------------------------------------------------------------------------"
267 echo "pstat -s"
268 echo
269 pstat -M $VMCORE -N $KERNEL -s
270 echo
271
272 echo "------------------------------------------------------------------------"
273 echo "iostat"
274 echo
275 iostat -M $VMCORE -N $KERNEL
276 echo
277
278 echo "------------------------------------------------------------------------"
279 echo "ipcs -a"
280 echo
281 ipcs -C $VMCORE -N $KERNEL -a
282 echo
283
284 echo "------------------------------------------------------------------------"
285 echo "ipcs -T"
286 echo
287 ipcs -C $VMCORE -N $KERNEL -T
288 echo
289
290 # XXX: This doesn't actually work in 5.x+
291 if false; then
292 echo "------------------------------------------------------------------------"
293 echo "w -dn"
294 echo
295 w -M $VMCORE -N $KERNEL -dn
296 echo
297 fi
298
299 echo "------------------------------------------------------------------------"
300 echo "netstat -s"
301 echo
302 netstat -M $VMCORE -N $KERNEL -s
303 echo
304
305 echo "------------------------------------------------------------------------"
306 echo "netstat -m"
307 echo
308 netstat -M $VMCORE -N $KERNEL -m
309 echo
310
311 echo "------------------------------------------------------------------------"
312 echo "netstat -anA"
313 echo
314 netstat -M $VMCORE -N $KERNEL -anA
315 echo
316
317 echo "------------------------------------------------------------------------"
318 echo "netstat -aL"
319 echo
320 netstat -M $VMCORE -N $KERNEL -aL
321 echo
322
323 echo "------------------------------------------------------------------------"
324 echo "fstat"
325 echo
326 fstat -M $VMCORE -N $KERNEL
327 echo
328
329 echo "------------------------------------------------------------------------"
330 echo "dmesg"
331 echo
332 dmesg -a -M $VMCORE -N $KERNEL
333 echo
334
335 echo "------------------------------------------------------------------------"
336 echo "kernel config"
337 echo
338 config -x $KERNEL
339
340 echo
341 echo "------------------------------------------------------------------------"
342 echo "ddb capture buffer"
343 echo
344
345 ddb capture -M $VMCORE -N $KERNEL print